;  ..
; a_biv @ list . ru    
;  . ., 22  2002. 2:5022/88.10
       LIST P=16f628
	   #include <p16f628.inc>       ; processor specific variable definitions
       __CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF & _LVP_OFF
;---------------------------------------------
	        cblock	   0x20
			LED0                ; 
			LED1                ; 
			LED2                ; 
			LED3                ;        
			LED4                ;           
			LED5                ; 
			KeyU                ; 
			KeyD                ;  
			KeyR                ;    
			KeyL                ;      
			KeyS                ;       
			KeyRes              ;         
			TempInd				; 
								; ----------------->>> Bin2Bcd
			Count1              ;  
			Count2              ;  
			Tmp_Led0            ;  LED
			Tmp_Led1            ;  LED
			Temp_BCD            ;    BCD
								; --------------->>> 
			Hour_b              ;      
			Min_b               ;      
			Sec_b               ;      
			endc
	;-------     16  ---->>>  
            cblock	   0x70
			Count               ;   
			AlarmDel            ;   
			Flags               ; 
			Hour                ;       
			Min                 ;       
			Sec                 ;       
			W_TEMP				;  W
			STATUS_TEMP			;  STATUS
			Temp                ;    
			Xcoord              ;   := 0,1,2
			Ycoord              ;   Y - 
			LED_L               ;
			LED_H               ; 
	        endc
;--------------------------------------------- const
KeyDelay	equ		   0xF6     ;   
;---------------------------------------------
SetupF      equ        0           ; [Flags] 1-  SETUP` 0-  MAIN`
;=============================================
            org        0x0000
			goto	   Init
;=============================================
            org        0x0004
			MOVWF 	   W_TEMP 		; W  
			SWAPF 	   STATUS,W 	;      W
			CLRF 	   STATUS 		;  0
			MOVWF 	   STATUS_TEMP  ;  STATUS
			clrf	   PORTB       ;  
			clrf	   PIR1        ;  
			bcf		   T1CON,TMR1ON
			bsf	   	   TMR1H,7	   ;  32768 
			bsf		   T1CON,TMR1ON
			incf	   Sec,F       ; ------------------  INC  
			movlw	   0x3C
			subwf	   Sec,W	   ; W:=Sec-60	   
			btfss	   STATUS,Z	   ; If 0 skip
			goto	   NextStep
			clrf	   Sec
			incf	   Min,F
			movlw	   0x3C
			subwf	   Min,W	   ; W:=Min-60	   
			btfss	   STATUS,Z	   ; If 0 skip
			goto	   NextStep
			clrf	   Min
			incf	   Hour,F
			movlw	   0x18
			subwf	   Hour,W	   ; W:=Hour-24	   
			btfsc	   STATUS,Z	   ; If 0 skip
			clrf	   Hour
NextStep       ; -----------------------    
	        movf	   AlarmDel,w
			subwf	   Sec,w
			btfss	   STATUS,Z    ; if W=0 then   
			goto	   RetInt
			movlw	   b'00000011'
			movwf	   PORTB
            movlw      0x30		   ;    -
            movwf      Temp 	   ;   		    	-
RetttOFF			   		       ;				-
	        bcf        STATUS,Z	   ;				-
	        decf       Temp,F	   ;				-
	        btfss      STATUS,Z	   ;				-
            goto       RetttOFF    ;  ---------------		
			goto	   IntOut
RetInt
	        movf	   Sec,w
			btfss	   STATUS,Z
			goto	   IntOut        ;    - 
	        movf	   Hour,w
			btfsc	   STATUS,Z
			goto	   IntOut        ;   -  
			bsf		   STATUS,RP0
			clrf	   Count
RetEE
			incf	   Count,F
			bcf		   STATUS,C
			decf	   Count,w
			movwf	   EEADR
			rlf	       EEADR,f
			incf	   EEADR,f
			bsf		   EECON1,RD
			movf	   EEDATA,w  ;   EEDATA - 
			subwf	   Hour,W
			btfss	   STATUS,Z
			goto	   NextEE    ;      
			incf	   EEADR,F   ;    
			bsf		   EECON1,RD
			movf	   EEDATA,w  ;   EEDATA - 
			subwf	   Min,W
			btfss	   STATUS,Z
			goto	   NextEE      ;      
			bcf		   STATUS,RP0
			movlw	   b'00001100' ;  
			movwf	   PORTB
            movlw      0x30		   ;    -
            movwf      Temp 	   ;   		    	-
RetttON			   		           ;				-
	        bcf        STATUS,Z	   ;				-
	        decf       Temp,F	   ;				-
	        btfss      STATUS,Z	   ;				-
            goto       RetttON     ;  ---------------		
			goto	   IntOut
NextEE
			movlw	   0x3F
			subwf	   Count,W
			btfss	   STATUS,Z
			goto	   RetEE
			bcf		   STATUS,RP0
IntOut
            SWAPF      STATUS_TEMP,W  ;  STATUS_TEMP
            MOVWF      STATUS         ; W   STATUS
            swapf      W_TEMP,F
            swapf      W_TEMP,w
			retfie
;==================================================================
LCDTable               ; GE_DCBAF    BCD -> 7  
            addwf      PCL,F       ; W + PC -> PC       
            retlw      b'10100000' ; GE_DCBAF = '0'     
            retlw      b'11110011' ;             1      
            retlw      b'00101001' ;            '2'      
            retlw      b'01100001' ;            '3'     
            retlw      b'01110010' ;            '4'       
            retlw      b'01100100' ;            '5'     
            retlw      b'00100100' ;            '6'     7 
            retlw      b'11110001' ;            '7'     
            retlw      b'00100000' ;            '8'       
            retlw      b'01100000' ;            '9'     
            retlw      b'10100010' ;            'V'     
            retlw      b'00111111' ;            'r'     
            retlw      b'10101100' ;            'C'     
            retlw      b'01111111' ;            '-'     
            retlw      b'00101100' ;            'E'     
            retlw      b'11111111' ; ........ = ' '     
;=============================================
SetUp   ;      SetUp`a
            bsf        Flags,SetupF
			clrf	   Sec
			movf	   Ycoord,w
			btfss	   STATUS,Z
			goto	   LED0_vr
			movlw	   0x0B
			movwf	   LED0
			movlw	   0x0A
			movwf	   LED1
			goto	   LED0_next
LED0_vr
			movlw	   0x40
			subwf	   Ycoord,w
			btfss	   STATUS,Z
			goto	   LED0_ce
			movlw	   0x0C
			movwf	   LED0
			movlw	   0x0E
			movwf	   LED1
			movlw	   0x0D
			movwf	   LED4
			movlw	   0x0D
			movwf	   LED5
			goto	   LED5_next
LED0_ce
	   		movf	   Ycoord,w
			movwf	   Temp_BCD
			call	   Bin2Bcd
			movf	   Tmp_Led0,w
			movwf	   LED0
			movf	   Tmp_Led1,w
			movwf	   LED1
LED0_next
			movf	   LED_H,w
			movwf	   Temp_BCD
			call	   Bin2Bcd
			movf	   Tmp_Led0,w
			movwf	   LED4
			movf	   Tmp_Led1,w
			movwf	   LED5
LED5_next
			movf	   LED_L,w
			movwf	   Temp_BCD
			call	   Bin2Bcd
			movf	   Tmp_Led0,w
			movwf	   LED2
			movf	   Tmp_Led1,w
			movwf	   LED3
;  4  TMR1H - LED (0,1), (2,3)  (4,5)  Xcoord 0,1  2
            btfss	   TMR1H,4
			goto	   SetUpOut      ; 
			movf	   Xcoord,w		 ;  
			addwf	   PCL,f
			goto	   SetUpOut0
			goto	   SetUpOut1
			movlw	   0x0F
			movwf	   LED4     ;  2
			movwf	   LED5
			goto	   SetUpOut
SetUpOut0			
			movlw	   0x0F
			movwf	   LED0    ;  0
			movwf	   LED1
			goto	   SetUpOut
SetUpOut1
			movlw	   0x0F
			movwf	   LED2    ;  1
			movwf	   LED3
SetUpOut
            call       LEDCycle
			goto	   SetUp
; ----------------------------------------------------------------
Up_Key
			btfss      Flags,SetupF
			return
			movf	   Xcoord,w
			addwf	   PCL,f
			goto	   Up_y0       ; 0
			goto	   Up_y1       ; 1
			incf	   LED_H,f     ; 2
			movlw	   0x18
			subwf	   LED_H,W	   ; W:=Hour-24	   
			btfsc	   STATUS,Z	   ; If 0 skip
			clrf	   LED_H
			return
Up_y1
			incf	   LED_L,f     ; 1
			movlw	   0x3C
			subwf	   LED_L,W	   ; W:=Min-60	   
			btfsc	   STATUS,Z	   ; If 0 skip
			clrf	   LED_L
			return
Up_y0
			movf	   Ycoord,w    ;    
			btfss	   STATUS,Z
			goto	   Up_y0_0			
	  		movf	   LED_L,w
			movwf	   Min
	  		movf	   LED_H,w
			movwf	   Hour
			goto	   Up_y0_Next
Up_y0_0
			call	   EE_wr
Up_y0_Next
			incf	   Ycoord,f	 	; 
	 		movlw      0x41 	   ;  + 63  +  
			subwf      Ycoord,w
			btfsc	   STATUS,Z
			clrf	   Ycoord
			goto	   Dw_Up_y0
;---------------------------------------------
Dw_Key
			btfss      Flags,SetupF
			return
			movf	   Xcoord,w
			addwf	   PCL,f
			goto	   Dw_y0       ; 0
			goto	   Dw_y1       ; 1
			decf	   LED_H,f     ; 2
			movlw	   0xFF
			subwf	   LED_H,W	   
			btfss	   STATUS,Z	   ; If 0 skip
			return
			movlw	   0x17
			movwf	   LED_H
			return
Dw_y1
			decf	   LED_L,f     ; 1
			movlw	   0xFF
			subwf	   LED_L,W	   
			btfss	   STATUS,Z	   ; If 0 skip
			return
			movlw	   0x3B
			movwf	   LED_L
			return
Dw_y0
			movf	   Ycoord,w    ;    
			btfss	   STATUS,Z
			goto	   Dw_y0_0			
	  		movf	   LED_L,w
			movwf	   Min
	  		movf	   LED_H,w
			movwf	   Hour
			goto	   Dw_y0_Next
Dw_y0_0
			call	   EE_wr
Dw_y0_Next
			decf	   Ycoord,f     ; 0
			movlw	   0xFF
			subwf	   Ycoord,W	   
			btfss	   STATUS,Z	   ; If 0 skip
			goto	   Dw_Up_y0
			movlw	   0x40
			movwf	   Ycoord
Dw_Up_y0       ; -------   Up  Dw ----------
			movf	   Ycoord,w    ;   
			btfss	   STATUS,Z    ;    
			goto	   Dw_y0_w
			movf	   Hour,w      ; 
			movwf	   LED_H
			movf	   Min,w
			movwf	   LED_L
			return
Dw_y0_w
			bsf		   STATUS,RP0
			movlw	   0x40           ;   64 
			subwf      Ycoord,w
			btfss	   STATUS,Z
			goto	   EE_rd_next
			clrf	   EEADR	      ;   
			goto	   EE_rd_nt_00
EE_rd_next
			bcf		   STATUS,C
			decf	   Ycoord,w
			movwf	   EEADR
			rlf	       EEADR,f
			incf	   EEADR,f
			bsf		   EECON1,RD
			movf	   EEDATA,w
			movwf	   LED_H
			incf	   EEADR
EE_rd_nt_00
			bsf		   EECON1,RD
			movf	   EEDATA,w
			movwf	   LED_L
			bcf		   STATUS,RP0
			return
;*******************************************************************
EE_wr					;    
			movlw	   0x40           ;   64 
			subwf      Ycoord,w
			btfss	   STATUS,Z
			goto	   EE_wr_next
			;   
			BCF 	   INTCON,GIE     ;  
			bsf		   STATUS,RP0
			clrf	   EEADR
			movf	   LED_L,w
			movwf	   AlarmDel
			movwf	   EEDATA
			BSF 	   EECON1,WREN    ;  
			goto	   EE_wr_00
EE_wr_next
			BCF 	   INTCON,GIE     ;  
			bsf		   STATUS,RP0
			bcf		   STATUS,C
			decf	   Ycoord,w
			movwf	   EEADR
			rlf	       EEADR,f
			incf	   EEADR,f
			movf	   LED_H,w
			movwf	   EEDATA
			BSF 	   EECON1,WREN    ;  
			goto	   EE_wr_2
;---------------------------------------------
Rg_Key                   ;   -  0
			btfss      Flags,SetupF
			return
			movf  	   Xcoord,w
			btfss	   STATUS,Z
			decf       Xcoord,F
			return
;---------------------------------------------
Lf_Key                   ;   +  2
			btfss      Flags,SetupF
			return
			movlw      2
			subwf	   Xcoord,W
			btfss	   STATUS,Z
			incf       Xcoord,F
			return
;---------------------------------------------
Sl_Key
			btfsc      Flags,SetupF
			goto	   Main
			clrf	   Ycoord
			clrf	   Xcoord
			movf	   Hour,w
			movwf	   LED_H
			movf	   Min,w
			movwf	   LED_L
			goto	   SetUp
;---------------------------------------------
Res_Key         ;  EEPROM`  RESET
			btfss      Flags,SetupF
			return
			return   ;   !
;---------------------------------------------
Init
            clrf	   STATUS
            movlw      b'11000000'
            movwf      INTCON
			movlw      b'00001011'
            movwf      T1CON
			movlw      0x07
            movwf      CMCON
			clrf	   CCP1CON
            bsf        STATUS,RP0
			clrf       TRISA
            clrf       TRISB       ; (all out)
            clrf	   VRCON
			movlw      b'00000001'
            movwf      PIE1
            bcf        STATUS,RP0  ;   0
			movlw	   b'00000011'
			movwf	   PORTB
			movlw      0x70		   ;    -
            movwf      TempInd 	   ;   		    	-
ReinOFF	     		   		       ;				-
	        bcf        STATUS,Z	   ;				-
	        decf       TempInd,F   ;				-
	        btfss      STATUS,Z	   ;				-
            goto       ReinOFF     ;  ---------------		
			movlw	   0x20
			movwf	   FSR    ;   
ClearReg
		    clrf	   INDF
			incf	   FSR,f
			btfss	   FSR,7
			goto	   ClearReg
            bsf        STATUS,RP0 ;  EEPROM`   
			clrf	   EEADR
			bsf		   EECON1,RD
			movf	   EEDATA,w
			movwf	   AlarmDel
            bcf        STATUS,RP0  ;   0
			goto	   SetUp
; ------------------------------------   ----
Main   ;      
			bcf        Flags,SetupF
            movf       Sec,w
			movwf	   Temp_BCD
			call	   Bin2Bcd
            movf       Tmp_Led0,w
			movwf	   LED0
            movf       Tmp_Led1,w
			movwf	   LED1
            movf       Min,w
			movwf	   Temp_BCD
			call	   Bin2Bcd
            movf       Tmp_Led0,w
			movwf	   LED2
            movf       Tmp_Led1,w
			movwf	   LED3
            movf       Hour,w
			movwf	   Temp_BCD
			call	   Bin2Bcd
            movf       Tmp_Led0,w
			movwf	   LED4
            movf       Tmp_Led1,w
			movwf	   LED5
            call       LEDCycle
			goto	   Main
;==============================================================
Bin2Bcd                  ; ------------------    BCD
            bcf        STATUS,C  ; clear the carry bit
            movlw      .8
            movwf      Count2    ; Count:= 8 - 
            clrf       Tmp_Led1  ;  
            clrf       Tmp_Led0
loop16
            rlf        Temp_BCD,f    ;  
            rlf        Tmp_Led0,f    ;    CF
            rlf        Tmp_Led1,f    ;    CF
            decfsz     Count2,f      ;Count:=Count-1,if Count=0 then skip next cmd
            goto       adjDEC
            swapf      Tmp_Led0,w    ;   LED0  
            andlw      0Fh           ;  -> w, w-> AND `00001111`
            movwf      Tmp_Led1      ; LED1:=w
            movfw      Tmp_Led0      ; w:= LED0
            andlw      0Fh           ;  -> w, w-> AND `00001111`
            movwf      Tmp_Led0      ; LED0:=w
            return                          ;  
adjDEC
            movlw      Tmp_Led0      ; w:= `H LED0`
            movwf      FSR           ; FSR:= w
            call       adjBCD
            movlw      Tmp_Led1      ; w:= `H LED1`
            movwf      FSR           ; FSR:= w
            call       adjBCD
            goto       loop16
adjBCD
            movlw      3         ; w:= 3
            addwf      0,W       ; w:= IndF + 3
            movwf      Count1    ; Count1:= w
            btfsc      Count1,3  ; test if result > 7  if 3 Count1=0 - skip next cmd
            movwf      0         ; IndF:= w
            movlw      30        ; w:= 30
            addwf      0,W       ; w:= IndF + 30
            movwf      Count1    ; Count1:= w
            btfsc      Count1,7  ; test if result > 7  if 7 Count1=0 - skip next cmd
            movwf      0         ; save as MSD      IndF:= w
            retlw      0         ; w:= 0
;---------------------------------------------
LEDCycle  
			movf	   LED5,w    ;  LED5
			call	   LCDTable
			movwf	   PORTA
			bsf		   PORTB,0
			nop
			btfsc	   PORTA,5
			goto	   KeyU_N
			movlw	   KeyDelay
			movwf	   KeyU
KeyU_N
			incf	   KeyU,F
			btfsc	   STATUS,Z
			call	   Up_Key
			call	   Dellay_
			movf	   LED4,w    ;  LED4
			call	   LCDTable
			movwf	   PORTA
			bsf		   PORTB,1
			nop
			btfsc	   PORTA,5
			goto	   KeyD_N
			movlw	   KeyDelay
			movwf	   KeyD
KeyD_N
			incf	   KeyD,F
			btfsc	   STATUS,Z
			call	   Dw_Key
			call	   Dellay_
			movf	   LED2,w    ;  LED2
			call	   LCDTable
			movwf	   PORTA
			bsf		   PORTB,2
			nop
			btfsc	   PORTA,5
			goto	   KeyR_N
			movlw	   KeyDelay
			movwf	   KeyR
KeyR_N
			incf	   KeyR,F
			btfsc	   STATUS,Z
			call	   Rg_Key
			call	   Dellay_
			movf	   LED3,w    ;  LED3
			call	   LCDTable
			movwf	   PORTA
			bsf		   PORTB,3
			nop
			btfsc	   PORTA,5
			goto	   KeyL_N
			movlw	   KeyDelay
			movwf	   KeyL
KeyL_N
			incf	   KeyL,F
			btfsc	   STATUS,Z
			call	   Lf_Key
			call	   Dellay_
			movf	   LED1,w    ;  LED1
			call	   LCDTable
			movwf	   PORTA
			bsf		   PORTB,4
			nop
			btfss	   PORTA,5
			clrf	   KeyRes
			incf	   KeyRes,F
			btfsc	   STATUS,Z
			goto	   Res_Key
			call	   Dellay_
			movf	   LED0,w    ;  LED0
			call	   LCDTable
			movwf	   PORTA
			bsf		   PORTB,5
			nop
			btfsc	   PORTA,5
			goto	   KeyS_N
			movlw	   KeyDelay
			movwf	   KeyS
KeyS_N
			incf	   KeyS,F
			btfsc	   STATUS,Z
			goto	   Sl_Key
			call	   Dellay_
	 		return
Dellay_			; -------------   
            movlw      0xFF		   ;    -
            movwf      TempInd 	   ;   		    	-
Rettt				   		       ;				-
	        bcf        STATUS,Z	   ;				-
	        decf       TempInd,F   ;				-
	        btfss      STATUS,Z	   ;				-
            goto       Rettt	   ;  ---------------		
			clrf	   PORTB
			return
;*******************************************************************
EE_wr_2
			MOVLW 	   0x55 
			MOVWF 	   EECON2         ;  55h
			MOVLW 	   0xAA 
			MOVWF 	   EECON2         ;  AAh
			BSF 	   EECON1,WR      ;   WR
LOOP_EE
            BTFSC      EECON1,WR
            GOTO       LOOP_EE
			incf	   EEADR
			movf	   LED_L,w
			movwf	   EEDATA
			BSF 	   EECON1,WREN    ;  
EE_wr_00
			MOVLW 	   0x55 
			MOVWF 	   EECON2         ;  55h
			MOVLW 	   0xAA 
			MOVWF 	   EECON2         ;  AAh
			BSF 	   EECON1,WR      ;   WR
			bcf		   EECON1,WREN
			BSF 	   INTCON,GIE     ;  
LOOP_EE1
            BTFSC      EECON1,WR
            GOTO       LOOP_EE1
			bcf		   STATUS,RP0
			return
;=============================================
            ORG     0x07FF
			goto	Init
;=============================================
            ORG     0x2100
			DE		.20  
			DE		.8,.00
			DE		.8,.05
			DE		.8,.50
			DE		.9,.00
			DE		.9,.45
			DE		.9,.50
			DE		.10,.35
			DE		.10,.45
			DE		.11,.30
			DE		.11,.40
			DE		.12,.25
			DE		.12,.30
			DE		.13,.15
			DE		.13,.45
			DE		.14,.30
			DE		.15,.45
			fill	0x00,95

            end
;=============================================
